# -*- coding: utf-8 -*-

"""
form3publicapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
import dateutil.parser

from form3publicapi.api_helper import APIHelper


class Attributes65(object):

    """Implementation of the 'Attributes65' model.

    TODO: type model description here.

    Attributes:
        redirected_account_number (str): Details of the account to which funds
            are redirected (if applicable)
        redirected_bank_id (str): Details of the bank to which funds are
            redirected (if applicable)
        route (Route1Enum): Route taken for a return
        scheme_status_code (str): Scheme-specific status (if submission has
            been submitted to a scheme)
        scheme_status_code_description (str):
            [Description](http://api-docs.form3.tech/api.html#enumerations-sche
            me-status-codes-for-bacs) of `scheme_status_code`
        settlement_cycle (int): Cycle in which the payment will be settled
        settlement_date (date): Date that the payment will be settled
        status (ReturnSubmissionStatusEnum):
            [Status](http://draft-api-docs.form3.tech/api.html#enumerations-pay
            ment-submission-status) of the submission
        status_reason (str): Description of the submission status

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "redirected_account_number": 'redirected_account_number',
        "redirected_bank_id": 'redirected_bank_id',
        "route": 'route',
        "scheme_status_code": 'scheme_status_code',
        "scheme_status_code_description": 'scheme_status_code_description',
        "settlement_cycle": 'settlement_cycle',
        "settlement_date": 'settlement_date',
        "status": 'status',
        "status_reason": 'status_reason'
    }

    _optionals = [
        'redirected_account_number',
        'redirected_bank_id',
        'route',
        'scheme_status_code',
        'scheme_status_code_description',
        'settlement_cycle',
        'settlement_date',
        'status',
        'status_reason',
    ]

    def __init__(self,
                 redirected_account_number=APIHelper.SKIP,
                 redirected_bank_id=APIHelper.SKIP,
                 route=APIHelper.SKIP,
                 scheme_status_code=APIHelper.SKIP,
                 scheme_status_code_description=APIHelper.SKIP,
                 settlement_cycle=APIHelper.SKIP,
                 settlement_date=APIHelper.SKIP,
                 status=APIHelper.SKIP,
                 status_reason=APIHelper.SKIP):
        """Constructor for the Attributes65 class"""

        # Initialize members of the class
        if redirected_account_number is not APIHelper.SKIP:
            self.redirected_account_number = redirected_account_number 
        if redirected_bank_id is not APIHelper.SKIP:
            self.redirected_bank_id = redirected_bank_id 
        if route is not APIHelper.SKIP:
            self.route = route 
        if scheme_status_code is not APIHelper.SKIP:
            self.scheme_status_code = scheme_status_code 
        if scheme_status_code_description is not APIHelper.SKIP:
            self.scheme_status_code_description = scheme_status_code_description 
        if settlement_cycle is not APIHelper.SKIP:
            self.settlement_cycle = settlement_cycle 
        if settlement_date is not APIHelper.SKIP:
            self.settlement_date = settlement_date 
        if status is not APIHelper.SKIP:
            self.status = status 
        if status_reason is not APIHelper.SKIP:
            self.status_reason = status_reason 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        redirected_account_number = dictionary.get("redirected_account_number") if dictionary.get("redirected_account_number") else APIHelper.SKIP
        redirected_bank_id = dictionary.get("redirected_bank_id") if dictionary.get("redirected_bank_id") else APIHelper.SKIP
        route = dictionary.get("route") if dictionary.get("route") else APIHelper.SKIP
        scheme_status_code = dictionary.get("scheme_status_code") if dictionary.get("scheme_status_code") else APIHelper.SKIP
        scheme_status_code_description = dictionary.get("scheme_status_code_description") if dictionary.get("scheme_status_code_description") else APIHelper.SKIP
        settlement_cycle = dictionary.get("settlement_cycle") if dictionary.get("settlement_cycle") else APIHelper.SKIP
        settlement_date = dateutil.parser.parse(dictionary.get('settlement_date')).date() if dictionary.get('settlement_date') else APIHelper.SKIP
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        status_reason = dictionary.get("status_reason") if dictionary.get("status_reason") else APIHelper.SKIP
        # Return an object of this model
        return cls(redirected_account_number,
                   redirected_bank_id,
                   route,
                   scheme_status_code,
                   scheme_status_code_description,
                   settlement_cycle,
                   settlement_date,
                   status,
                   status_reason)
