# -*- coding: utf-8 -*-

"""
form3publicapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from form3publicapi.api_helper import APIHelper
from form3publicapi.models.account_holding_entity import AccountHoldingEntity
from form3publicapi.models.beneficiary_debtor_organisation_identification import BeneficiaryDebtorOrganisationIdentification
from form3publicapi.models.private_identification import PrivateIdentification


class DebtorParty2(object):

    """Implementation of the 'DebtorParty2' model.

    TODO: type model description here.

    Attributes:
        account_name (str): Name of debtor as given with account
        account_number (str): Debtor account number. Allows upper case and
            numeric characters.
        account_number_code (AccountNumberCodeEnum): The type of
            identification given at `account_number` attribute
        account_with (AccountHoldingEntity): Information about the financial
            institution servicing the account.
        address (List[str]): Debtor address
        building_number (str): Building number of the Debtor address
        city (str): City/Town of the Debtor address
        country (str): Country of debtor address. ISO 3166 format country
            code"
        name (str): Debtor name
        organisation_identification (str): Organisation identification of a
            beneficiary, used in the case that the beneficiary is an
            organisation and not a private person
        organisation_identification_code (str): The code that specifies the
            type of `organisation_identification`
        organisation_identification_issuer (str): Issuer of the
            `organisation_identification`
        organisation_identification_scheme (str): The code that specifies the
            scheme of `organisation_identification`
        organisation_identifications
            (List[BeneficiaryDebtorOrganisationIdentification]): Array for
            additional ID(s) of ultimate organisation
        post_code (str): Post code of the Debtor address
        private_identification (PrivateIdentification): TODO: type description
            here.
        province (str): Province of the Debtor address
        street_name (str): Street name of the Debtor address

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "account_name": 'account_name',
        "account_number": 'account_number',
        "account_number_code": 'account_number_code',
        "account_with": 'account_with',
        "address": 'address',
        "building_number": 'building_number',
        "city": 'city',
        "country": 'country',
        "name": 'name',
        "organisation_identification": 'organisation_identification',
        "organisation_identification_code": 'organisation_identification_code',
        "organisation_identification_issuer": 'organisation_identification_issuer',
        "organisation_identification_scheme": 'organisation_identification_scheme',
        "organisation_identifications": 'organisation_identifications',
        "post_code": 'post_code',
        "private_identification": 'private_identification',
        "province": 'province',
        "street_name": 'street_name'
    }

    _optionals = [
        'account_name',
        'account_number',
        'account_number_code',
        'account_with',
        'address',
        'building_number',
        'city',
        'country',
        'name',
        'organisation_identification',
        'organisation_identification_code',
        'organisation_identification_issuer',
        'organisation_identification_scheme',
        'organisation_identifications',
        'post_code',
        'private_identification',
        'province',
        'street_name',
    ]

    def __init__(self,
                 account_name=APIHelper.SKIP,
                 account_number=APIHelper.SKIP,
                 account_number_code=APIHelper.SKIP,
                 account_with=APIHelper.SKIP,
                 address=APIHelper.SKIP,
                 building_number=APIHelper.SKIP,
                 city=APIHelper.SKIP,
                 country=APIHelper.SKIP,
                 name=APIHelper.SKIP,
                 organisation_identification=APIHelper.SKIP,
                 organisation_identification_code=APIHelper.SKIP,
                 organisation_identification_issuer=APIHelper.SKIP,
                 organisation_identification_scheme=APIHelper.SKIP,
                 organisation_identifications=APIHelper.SKIP,
                 post_code=APIHelper.SKIP,
                 private_identification=APIHelper.SKIP,
                 province=APIHelper.SKIP,
                 street_name=APIHelper.SKIP):
        """Constructor for the DebtorParty2 class"""

        # Initialize members of the class
        if account_name is not APIHelper.SKIP:
            self.account_name = account_name 
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if account_number_code is not APIHelper.SKIP:
            self.account_number_code = account_number_code 
        if account_with is not APIHelper.SKIP:
            self.account_with = account_with 
        if address is not APIHelper.SKIP:
            self.address = address 
        if building_number is not APIHelper.SKIP:
            self.building_number = building_number 
        if city is not APIHelper.SKIP:
            self.city = city 
        if country is not APIHelper.SKIP:
            self.country = country 
        if name is not APIHelper.SKIP:
            self.name = name 
        if organisation_identification is not APIHelper.SKIP:
            self.organisation_identification = organisation_identification 
        if organisation_identification_code is not APIHelper.SKIP:
            self.organisation_identification_code = organisation_identification_code 
        if organisation_identification_issuer is not APIHelper.SKIP:
            self.organisation_identification_issuer = organisation_identification_issuer 
        if organisation_identification_scheme is not APIHelper.SKIP:
            self.organisation_identification_scheme = organisation_identification_scheme 
        if organisation_identifications is not APIHelper.SKIP:
            self.organisation_identifications = organisation_identifications 
        if post_code is not APIHelper.SKIP:
            self.post_code = post_code 
        if private_identification is not APIHelper.SKIP:
            self.private_identification = private_identification 
        if province is not APIHelper.SKIP:
            self.province = province 
        if street_name is not APIHelper.SKIP:
            self.street_name = street_name 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        account_name = dictionary.get("account_name") if dictionary.get("account_name") else APIHelper.SKIP
        account_number = dictionary.get("account_number") if dictionary.get("account_number") else APIHelper.SKIP
        account_number_code = dictionary.get("account_number_code") if dictionary.get("account_number_code") else APIHelper.SKIP
        account_with = AccountHoldingEntity.from_dictionary(dictionary.get('account_with')) if 'account_with' in dictionary.keys() else APIHelper.SKIP
        address = dictionary.get("address") if dictionary.get("address") else APIHelper.SKIP
        building_number = dictionary.get("building_number") if dictionary.get("building_number") else APIHelper.SKIP
        city = dictionary.get("city") if dictionary.get("city") else APIHelper.SKIP
        country = dictionary.get("country") if dictionary.get("country") else APIHelper.SKIP
        name = dictionary.get("name") if dictionary.get("name") else APIHelper.SKIP
        organisation_identification = dictionary.get("organisation_identification") if dictionary.get("organisation_identification") else APIHelper.SKIP
        organisation_identification_code = dictionary.get("organisation_identification_code") if dictionary.get("organisation_identification_code") else APIHelper.SKIP
        organisation_identification_issuer = dictionary.get("organisation_identification_issuer") if dictionary.get("organisation_identification_issuer") else APIHelper.SKIP
        organisation_identification_scheme = dictionary.get("organisation_identification_scheme") if dictionary.get("organisation_identification_scheme") else APIHelper.SKIP
        organisation_identifications = None
        if dictionary.get('organisation_identifications') is not None:
            organisation_identifications = [BeneficiaryDebtorOrganisationIdentification.from_dictionary(x) for x in dictionary.get('organisation_identifications')]
        else:
            organisation_identifications = APIHelper.SKIP
        post_code = dictionary.get("post_code") if dictionary.get("post_code") else APIHelper.SKIP
        private_identification = PrivateIdentification.from_dictionary(dictionary.get('private_identification')) if 'private_identification' in dictionary.keys() else APIHelper.SKIP
        province = dictionary.get("province") if dictionary.get("province") else APIHelper.SKIP
        street_name = dictionary.get("street_name") if dictionary.get("street_name") else APIHelper.SKIP
        # Return an object of this model
        return cls(account_name,
                   account_number,
                   account_number_code,
                   account_with,
                   address,
                   building_number,
                   city,
                   country,
                   name,
                   organisation_identification,
                   organisation_identification_code,
                   organisation_identification_issuer,
                   organisation_identification_scheme,
                   organisation_identifications,
                   post_code,
                   private_identification,
                   province,
                   street_name)
