# -*- coding: utf-8 -*-

"""
form3publicapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from form3publicapi.api_helper import APIHelper
from form3publicapi.models.account_with_bank_id import AccountWithBankId


class Identification(object):

    """Implementation of the 'Identification' model.

    TODO: type model description here.

    Attributes:
        bank_id (str): Identification code of the financial institution.
        bank_id_code (str): Type of identification provided in bank_id field.
            Required when bank_id is provided, not used otherwise.
        bank_ids (List[AccountWithBankId]): Array for additional ID(s) of
            instructed (or other type of) agent

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "bank_id": 'bank_id',
        "bank_id_code": 'bank_id_code',
        "bank_ids": 'bank_ids'
    }

    _optionals = [
        'bank_id',
        'bank_id_code',
        'bank_ids',
    ]

    def __init__(self,
                 bank_id=APIHelper.SKIP,
                 bank_id_code=APIHelper.SKIP,
                 bank_ids=APIHelper.SKIP):
        """Constructor for the Identification class"""

        # Initialize members of the class
        if bank_id is not APIHelper.SKIP:
            self.bank_id = bank_id 
        if bank_id_code is not APIHelper.SKIP:
            self.bank_id_code = bank_id_code 
        if bank_ids is not APIHelper.SKIP:
            self.bank_ids = bank_ids 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        bank_id = dictionary.get("bank_id") if dictionary.get("bank_id") else APIHelper.SKIP
        bank_id_code = dictionary.get("bank_id_code") if dictionary.get("bank_id_code") else APIHelper.SKIP
        bank_ids = None
        if dictionary.get('bank_ids') is not None:
            bank_ids = [AccountWithBankId.from_dictionary(x) for x in dictionary.get('bank_ids')]
        else:
            bank_ids = APIHelper.SKIP
        # Return an object of this model
        return cls(bank_id,
                   bank_id_code,
                   bank_ids)
