# -*- coding: utf-8 -*-

"""
form3publicapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from form3publicapi.api_helper import APIHelper


class SendersCorrespondentAccountHoldingEntity(object):

    """Implementation of the 'SendersCorrespondentAccountHoldingEntity' model.

    TODO: type model description here.

    Attributes:
        bank_address (List[str]): Sender's correspondent's address
        bank_id (str): SWIFT BIC for sender's correspondent
        bank_id_code (str): The type of identification provided at `bank_id`
            attribute. Must be ISO code as listed in the [External Code Sets
            spreadsheet](https://www.iso20022.org/external_code_list.page)
        bank_name (str): Sender's correspondent's name
        bank_party_id (str): Identifier of the financial institution which
            services the account

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "bank_address": 'bank_address',
        "bank_id": 'bank_id',
        "bank_id_code": 'bank_id_code',
        "bank_name": 'bank_name',
        "bank_party_id": 'bank_party_id'
    }

    _optionals = [
        'bank_address',
        'bank_id',
        'bank_id_code',
        'bank_name',
        'bank_party_id',
    ]

    def __init__(self,
                 bank_address=APIHelper.SKIP,
                 bank_id=APIHelper.SKIP,
                 bank_id_code=APIHelper.SKIP,
                 bank_name=APIHelper.SKIP,
                 bank_party_id=APIHelper.SKIP):
        """Constructor for the SendersCorrespondentAccountHoldingEntity class"""

        # Initialize members of the class
        if bank_address is not APIHelper.SKIP:
            self.bank_address = bank_address 
        if bank_id is not APIHelper.SKIP:
            self.bank_id = bank_id 
        if bank_id_code is not APIHelper.SKIP:
            self.bank_id_code = bank_id_code 
        if bank_name is not APIHelper.SKIP:
            self.bank_name = bank_name 
        if bank_party_id is not APIHelper.SKIP:
            self.bank_party_id = bank_party_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        bank_address = dictionary.get("bank_address") if dictionary.get("bank_address") else APIHelper.SKIP
        bank_id = dictionary.get("bank_id") if dictionary.get("bank_id") else APIHelper.SKIP
        bank_id_code = dictionary.get("bank_id_code") if dictionary.get("bank_id_code") else APIHelper.SKIP
        bank_name = dictionary.get("bank_name") if dictionary.get("bank_name") else APIHelper.SKIP
        bank_party_id = dictionary.get("bank_party_id") if dictionary.get("bank_party_id") else APIHelper.SKIP
        # Return an object of this model
        return cls(bank_address,
                   bank_id,
                   bank_id_code,
                   bank_name,
                   bank_party_id)
